#include <iostream>
#include <map>
#include <set>
#include <algorithm>
#include <limits>
#include <cmath>
#include <cstdio>
#include <vector>
#include <queue>

#define DEBUG

#ifdef DEBUG
	#define DBG if (1)
#else
	#define DBG if (0)
#endif

#define PA(arr, n) DBG for (int i = 0; i < n; i++) printf("%d%c", arr[i], "\n "[i < n - 1])
#define PD(n) DBG printf("%d\n", n); 
#define PDBL(n) DBG printf("%lf\n", n);

using namespace std;

bool cmp1(const pair<int,int>&a, const pair<int,int>&b){
	return (a.first + a.second) < b.first + b.second;
}

bool cmp2(const pair<int,int>&a, const pair<int,int>&b){
	return a.first - a.second < b.first - b.second;
}


int main () {

	int n;
	while(scanf("%d", &n) == 1){

	vector< pair<int, int> > arr(n);
	for (int i = 0; i < n; i++) {
		scanf("%d %d", &arr[i].first, &arr[i].second);	
	}

	sort(arr.begin(),arr.end(), cmp1);
	int count = 1;
	int sum;
	for(int i = 0; i < n-1; i++){
		pair<int,int> a = arr[i];
		pair<int,int> b = arr[i+1];		
		if(a.first + a.second == b.first + b.second)
			count++;
		else{
			sum += (count*(count +1))/2;
			count = 1;
		}
		if(i == n-1){
			sum += (count*(count +1))/2;
			count = 1;
		}
	}
	sort(arr.begin(),arr.end(), cmp2);

	count = 1;
	for(int i = 0; i < n-1; i++){
		pair<int,int>  a = arr[i];
		pair<int,int>  b = arr[i+1];		
		if(a.first - a.second == b.first - b.second)
			count++;
		else{
			sum += (count*(count +1))/2;
			count = 1;
		}
		if(i == n-1){
			sum += (count*(count + 1))/2;
			count = 1;
		}
	}
	printf("%lf\n", (double)count*2/(double)(n*n));
	}

	return 0;

}
